{************************************************}
{*                                              *}
{* Atari Portfolio Beeper Music Engine (c)2014  *}
{* Data M&T Soft.                               *}
{*                                              *}
{* based on Huby music engine by Shiru          *}
{* (shiru@mail.ru)                              *}
{*                                              *}
{************************************************}
{last modified 14.3.2014}
{$M 1024,0,0}
var speed     : word;
    ptrnoffset: word;

 procedure GotoXY(X,Y:byte);assembler;
  asm
   mov bh,0
   mov dl,X
   mov dh,Y
   mov ah,2
   int $10
  end;

 procedure WriteXY(x,y:byte;s:string);
  begin
   GotoXY(x,y);
   write(s);
  end;

 procedure ClrScr;assembler;
  asm
   mov cx,0
   mov dh,7
   mov dl,79
   mov al,0
   mov ah,6
   mov bh,15
   int $10
   mov bh,0
   xor dx,dx
   mov ah,2
   int $10
  end;

begin
 ClrScr;
 asm
   mov al,1        {portfolio box}
   mov bh,0
   mov dx,0
   mov cx,$0727
   mov ah,$09
   int $60
 end;
 WriteXY(2,0,'Atari Portfolio Beeper Music engine');
 WriteXY(3,2,'Data M&T Soft. (c) 2014 version 1.0');
 WriteXY(3,3,'based on Huby music engine by Shiru');
 WriteXY(3,4,'(shiru@mail.ru)');
 WriteXY(8,7,'...to stop press ESC...');
 GotoXY(0,7);
 asm
  @start:
   lea bp,cs:@module
   mov ax,word ptr cs:[bp]
   mov speed,ax
   inc bp
   inc bp
   mov ax,word ptr cs:[bp]
   mov ptrnoffset,ax
   inc bp
   inc bp
  @readptn:
   mov ah,0
   mov al,byte ptr cs:[bp]
   cmp al,0
   jz @start
   add ax,ax
   add ax,ax
   add ax,ax
   add ax,ptrnoffset
   mov si,ax
   inc bp
   mov ah,0
   mov al,byte ptr cs:[bp]
   add ax,ax
   add ax,ax
   add ax,ax
   add ax,ptrnoffset
   mov di,ax
   inc bp
   mov cx,8
  @rowloop:
   mov bl,byte ptr cs:si
   mov bh,bl
   mov dl,byte ptr cs:di
   mov dh,dl
   inc si
   inc di
   cli
   push cx
   mov cx,speed
   cmp bl,$2C
   jz @@l5
   call @sndloop
   jmp @@l6
  @@l5:
   call @sndloop1
  @@l6:
   sti
   push ax
   mov ah,1
   int $16
   jz  @@l7
   mov ah,0
   int $16
   cmp al,27
   jne @@l7
   pop ax
   jmp @end
  @@l7:
   pop ax
   pop cx
   loop @rowloop
   jmp @readptn
  @sndloop:
   xor al,al
   dec bl
   jnz @@l1
   mov bl,bh
   sub al,bh
  @@l1:
   dec dl
   jnz @@l2
   mov dl,dh
   sub al,dh
  @@l2:
   sbb al,al
   and al,$80
   call @outport
   loop @sndloop
   ret
  @sndloop1:
   xor al,al
   dec bl
   jnz @@l3
   mov bl,bh
   sub al,bh
   inc bh
  @@l3:
   dec dl
   jnz @@l4
   mov dl,dh
   sub al,dh
  @@l4:
   sbb al,al
   and al,$80
   call @outport
   loop @sndloop1
   ret
  @outport:
   push dx
   mov dx,$8020
   out dx,al
   pop dx
   ret

{  @module:
   dw $0944
   dw @p-8
   db $01,$02
   db $00
  @p:
   db $10,$20,$30,$40,$50,$60,$70,$80
   db $11,$21,$31,$41,$51,$61,$71,$81}

    @module:
	dw $0844
	dw @p-8
	db $01,$02
	db $03,$04
	db $05,$06
	db $07,$08
	db $09,$0a
	db $0b,$0c
	db $01,$0d
	db $0e,$0f
	db $01,$02
	db $03,$04
	db $05,$06
	db $07,$10
	db $09,$11
	db $0b,$12
	db $05,$13
	db $14,$15
	db $16,$17
	db $18,$19
	db $1a,$17
	db $1b,$1c
	db $1d,$1e
	db $1f,$20
	db $1d,$1e
	db $21,$20
	db $16,$17
	db $18,$1c
	db $1a,$17
	db $1b,$22
	db $23,$24
	db $25,$24
	db $23,$26
	db $27,$28
	db $16,$17
	db $18,$19
	db $1a,$17
	db $1b,$1c
	db $1d,$1e
	db $1f,$20
	db $1d,$1e
	db $21,$20
	db $16,$17
	db $18,$1c
	db $1a,$17
	db $1b,$22
	db $29,$28
	db $2a,$28
	db $29,$2b
	db $2c,$2d
	db $00
      @p:
	db $e2,$00,$e2,$00,$e2,$00,$e2,$00
	db $00,$00,$38,$38,$32,$32,$2c,$2c
	db $2c,$00,$e2,$00,$e2,$00,$e2,$00
	db $38,$38,$38,$38,$3c,$3c,$38,$38
	db $97,$00,$97,$00,$97,$00,$97,$00
	db $38,$38,$3c,$3c,$00,$00,$00,$00
	db $2c,$00,$97,$00,$97,$00,$97,$00
	db $43,$43,$3c,$3c,$00,$00,$4b,$4b
	db $a9,$00,$a9,$00,$a9,$00,$a9,$00
	db $4b,$4b,$54,$54,$4b,$4b,$43,$43
	db $2c,$00,$a9,$00,$a9,$00,$a9,$00
	db $4b,$4b,$4b,$4b,$54,$54,$4b,$4b
	db $4b,$4b,$59,$00,$59,$00,$59,$00
	db $2c,$00,$ca,$00,$b3,$00,$b3,$00
	db $54,$00,$54,$00,$4b,$00,$4b,$00
	db $38,$38,$32,$32,$00,$00,$3c,$3c
	db $3c,$3c,$43,$43,$4b,$4b,$54,$54
	db $65,$65,$59,$59,$00,$00,$4b,$4b
	db $4b,$4b,$4b,$4b,$4b,$4b,$4b,$4b
	db $2c,$00,$97,$00,$2c,$00,$2c,$00
	db $4b,$4b,$4b,$4b,$00,$00,$00,$00
	db $a9,$00,$a9,$a9,$54,$00,$54,$54
	db $43,$43,$38,$38,$32,$32,$43,$43
	db $2c,$00,$a9,$a9,$54,$00,$54,$54
	db $38,$38,$32,$32,$38,$38,$32,$32
	db $97,$00,$97,$97,$4b,$00,$4b,$4b
	db $2c,$00,$97,$97,$2c,$00,$2c,$4b
	db $38,$38,$32,$32,$43,$43,$38,$38
	db $86,$00,$86,$86,$43,$00,$43,$43
	db $3c,$3c,$38,$38,$32,$32,$3c,$3c
	db $2c,$00,$86,$86,$43,$00,$43,$43
	db $38,$38,$32,$32,$3c,$3c,$38,$38
	db $2c,$00,$86,$86,$2c,$00,$2c,$43
	db $38,$38,$32,$32,$43,$43,$3c,$3c
	db $ca,$00,$ca,$ca,$65,$00,$65,$65
	db $43,$00,$43,$00,$43,$00,$43,$00
	db $2c,$00,$ca,$ca,$65,$00,$65,$65
	db $3c,$00,$3c,$00,$3c,$00,$3c,$00
	db $2c,$00,$ca,$ca,$65,$00,$65,$00
	db $38,$00,$38,$00,$38,$00,$38,$00
	db $e2,$00,$e2,$e2,$71,$00,$71,$71
	db $2c,$00,$e2,$e2,$71,$00,$71,$71
	db $38,$38,$38,$38,$38,$38,$38,$38
	db $2c,$e2,$e2,$e2,$e2,$00,$00,$00
	db $38,$38,$38,$38,$38,$00,$00,$00

 {   @module:
	dw $04f3
	dw @p-8
	db $01,$02
	db $01,$03
	db $04,$05
	db $06,$07
	db $08,$09
	db $0a,$0b
	db $0c,$0d
	db $0e,$0f
	db $01,$02
	db $01,$03
	db $04,$05
	db $06,$07
	db $08,$09
	db $0a,$0b
	db $0c,$0d
	db $0e,$0f
	db $10,$02
	db $11,$03
	db $12,$05
	db $13,$07
	db $14,$09
	db $15,$0b
	db $16,$0d
	db $17,$0f
	db $18,$02
	db $18,$03
	db $19,$05
	db $19,$07
	db $1a,$09
	db $1a,$0b
	db $1b,$0d
	db $1c,$0f
	db $01,$02
	db $01,$03
	db $04,$05
	db $06,$07
	db $08,$09
	db $0a,$0b
	db $0c,$0d
	db $0e,$0f
	db $1d,$02
	db $1d,$03
	db $1e,$05
	db $1e,$07
	db $1f,$09
	db $1f,$0b
	db $20,$0d
	db $21,$0f
	db $10,$02
	db $11,$03
	db $12,$05
	db $13,$07
	db $14,$09
	db $15,$0b
	db $16,$0d
	db $17,$0f
	db $18,$02
	db $18,$03
	db $19,$05
	db $19,$07
	db $1a,$09
	db $1a,$0b
	db $1b,$0d
	db $1c,$0f
	db $00
      @p:
	db $2c,$3c,$b3,$3c,$b3,$3c,$b3,$3c
	db $59,$59,$50,$50,$4b,$4b,$4b,$4b
	db $4b,$4b,$4b,$4b,$59,$59,$59,$59
	db $2c,$38,$b3,$38,$b3,$38,$b3,$38
	db $43,$43,$43,$43,$43,$43,$43,$43
	db $2c,$38,$b3,$38,$2c,$38,$2c,$38
	db $43,$43,$43,$43,$4b,$4b,$50,$50
	db $b3,$32,$b3,$32,$2c,$32,$b3,$32
	db $4b,$4b,$50,$50,$59,$59,$59,$59
	db $2c,$32,$b3,$32,$b3,$32,$b3,$32
	db $59,$59,$59,$59,$4b,$4b,$4b,$4b
	db $2c,$43,$b3,$43,$b3,$43,$b3,$43
	db $50,$50,$50,$50,$50,$50,$50,$50
	db $2c,$43,$b3,$43,$2c,$a0,$2c,$86
	db $50,$50,$50,$50,$43,$43,$3c,$3c
	db $2c,$3c,$e2,$3c,$e2,$3c,$2c,$3c
	db $2c,$3c,$e2,$3c,$2c,$3c,$2c,$3c
	db $2c,$38,$e2,$38,$e2,$38,$e2,$38
	db $e2,$38,$2c,$38,$2c,$38,$e2,$38
	db $2c,$32,$e2,$32,$2c,$32,$e2,$32
	db $e2,$32,$e2,$32,$2c,$32,$e2,$32
	db $2c,$43,$e2,$43,$e2,$43,$e2,$43
	db $2c,$43,$2c,$43,$2c,$2c,$2c,$2c
	db $f0,$3c,$f0,$3c,$f0,$3c,$f0,$3c
	db $f0,$38,$f0,$38,$f0,$38,$f0,$38
	db $f0,$32,$f0,$32,$f0,$32,$f0,$32
	db $f0,$43,$f0,$43,$f0,$43,$f0,$43
	db $f0,$43,$f0,$43,$f0,$a0,$f0,$86
	db $78,$3c,$78,$3c,$78,$3c,$78,$3c
	db $78,$38,$78,$38,$78,$38,$78,$38
	db $78,$32,$78,$32,$78,$32,$78,$32
	db $78,$43,$78,$43,$78,$43,$78,$43
	db $78,$43,$78,$43,$78,$a0,$78,$86 }

{@module:
	dw $0a96
	dw @p-8
	db $01,$02
	db $03,$04
	db $01,$05
	db $03,$06
	db $07,$08
	db $09,$0a
	db $0b,$0c
	db $0d,$0e
	db $01,$02
	db $03,$04
	db $01,$05
	db $03,$06
	db $07,$08
	db $09,$0a
	db $0b,$0c
	db $0d,$0e
	db $01,$02
	db $03,$04
	db $01,$05
	db $03,$06
	db $07,$08
	db $09,$0a
	db $0b,$0c
	db $0d,$0e
	db $01,$02
	db $03,$04
	db $01,$05
	db $03,$06
	db $07,$08
	db $09,$0a
	db $0b,$0c
	db $0d,$0e
	db $00
@p:
	db $2c,$86,$43,$43,$86,$86,$43,$43
	db $00,$00,$38,$00,$38,$3c,$3c,$38
	db $2c,$86,$2c,$43,$86,$86,$43,$43
	db $38,$00,$3c,$38,$38,$32,$32,$2c
	db $2c,$38,$38,$00,$38,$38,$3c,$38
	db $38,$38,$38,$38,$00,$00,$00,$00
	db $2c,$ca,$65,$65,$ca,$ca,$65,$65
	db $00,$00,$38,$00,$38,$3c,$00,$38
	db $2c,$ca,$2c,$65,$ca,$ca,$65,$65
	db $38,$00,$43,$3c,$3c,$38,$38,$32
	db $2c,$b3,$59,$59,$b3,$b3,$59,$59
	db $32,$32,$43,$3c,$3c,$3c,$38,$38
	db $2c,$b3,$2c,$59,$b3,$b3,$59,$59
	db $32,$32,$32,$32,$2c,$2c,$2c,$2c}

{ @module:
	dw $0de7
	dw @p-8
	db $01,$02
	db $03,$04
	db $05,$06
	db $05,$07
	db $05,$07
	db $05,$07
	db $05,$07
	db $05,$07
	db $05,$07
	db $05,$07
	db $05,$08
	db $05,$09
	db $05,$09
	db $05,$09
	db $05,$0a
	db $05,$0b
	db $05,$0b
	db $0c,$0b
	db $00
      @p:
	db $38,$71,$38,$71,$4b,$97,$4b,$97
	db $00,$00,$00,$00,$38,$71,$38,$71
	db $71,$e2,$71,$e2,$97,$97,$97,$97
	db $4b,$97,$4b,$97,$71,$e2,$71,$e2
	db $00,$97,$00,$00,$00,$00,$00,$00
	db $e2,$e2,$71,$71,$71,$71,$71,$71
	db $71,$71,$71,$71,$71,$71,$71,$71
	db $71,$71,$97,$97,$97,$97,$97,$97
	db $97,$97,$97,$97,$97,$97,$97,$97
	db $97,$97,$86,$86,$86,$86,$86,$86
	db $86,$86,$86,$86,$86,$86,$86,$86
	db $00,$97,$00,$00,$97,$97,$97,$97}

  @end:
 end;
 ClrScr;
end.